from core import world
from core.agents import *
import random

import pygame
class Chompy(Agent):
    def __init__(self):
        super(Chompy,self).__init__()
        self.load("art/chompy.png")
        self.pos = [160,220]
        self.hotspot = [24,64]
        self.full = 48
        self.next_digest = 120
    def draw(self,engine):
        head = self.surface.subsurface([[0,0],[48,32]])
        body = self.surface.subsurface([[0,32],[48,32]])
        body = pygame.transform.scale(body,[self.full,32])
        engine.surface.blit(head,[self.pos[0]-self.hotspot[0],self.pos[1]-self.hotspot[1]])
        engine.surface.blit(body,[self.pos[0]-self.hotspot[0]*(self.full/48.0),self.pos[1]-self.hotspot[1]+body.get_height()])
    def update(self,world):
        self.next_digest -= 1
        if self.next_digest <= 0:
            self.next_digest = 120
            world.add(Poop("art/chompyp.png",[self.pos[0]+random.randint(-3,3),self.pos[1]+random.randint(-3,3)]))
            self.full -= 2
        if self.full>200:
            for i in range(200):
                world.add(Poop("art/chompyp.png",[self.pos[0]+random.randint(-32,32),self.pos[1]+random.randint(-3,16)]))
            self.delete()
            world.engine.sound("art/fart.ogg")
        if self.full<=0:
            self.full = 0
            
class Poop(Agent):
    ttl = 1024
    def update(self,world):
        self.ttl -= 1
        if self.ttl < 0:
            self.delete()
            
class Burger(Agent):
    speed = 1
    fiber = 5
    bulk = 10
    def update(self,world):
        self.pos[1]+=self.speed
        d = (self.pos[0]-world.chompy.pos[0])**2+(self.pos[1]-(world.chompy.pos[1]-64))**2
        if d<16**2:
            self.delete()
            world.chompy.full+=self.bulk
            world.chompy.next_digest+=self.fiber
            world.engine.sound("art/belch.ogg")
        if self.pos[1]>240:
            self.delete()
            
class ChompyWorld(world.World):
    next_burger = 120
    def input(self,controller):
        if pygame.key.get_pressed()[pygame.K_LEFT]:
            self.chompy.pos[0]-=1
        if pygame.key.get_pressed()[pygame.K_RIGHT]:
            self.chompy.pos[0]+=1
        if self.chompy.pos[0]<16:
            self.chompy.pos[0] = 16
        if self.chompy.pos[0]>310:
            self.chompy.pos[0]=310
        super(ChompyWorld,self).input(controller)
    def update(self):
        self.next_burger -= 1
        if self.next_burger<0:
            self.add(Burger("art/cburger.png",[random.randint(0,320),random.randint(-50,-25)]))
            self.next_burger = random.randint(10,120)
        super(ChompyWorld,self).update()
        
def make_world(engine):
    """This makes the starting world"""
    w = ChompyWorld(engine)
    w.add(Agent("art/restaurant.png"))
    w.chompy = Chompy()
    w.add(w.chompy)
    return w
